/*
Copyright (C) 2010 Victor Matei Petrescu

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 3
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/


int valhex(char s)
{switch(s){
  case '0': return 0;
  case '1': return 1;
  case '2': return 2;
  case '3': return 3;
  case '4': return 4;
  case '5': return 5;
  case '6': return 6;
  case '7': return 7;
  case '8': return 8;
  case '9': return 9;
  case 'a': return 10;
  case 'b': return 11;
  case 'c': return 12;
  case 'd': return 13;
  case 'e': return 14;
  case 'f': return 15;
 }
 return 0;
}


/*hex e de forma "#6d54fc"*/
pixcol hexpix(char *hex,SDL_Surface *screen)
{pixcol pix;
 pix.red=16*valhex(hex[1])+valhex(hex[2]);
 pix.green=16*valhex(hex[3])+valhex(hex[4]);
 pix.blue=16*valhex(hex[5])+valhex(hex[6]);
 pix.bright=SDL_MapRGB(screen->format,pix.red,pix.green,pix.blue);
 return pix;
}


/*bmw=image width; bmh=image height*/
pixcol *readbkg(char *numefis,SDL_Surface *screen)
{int err,lincr=1,i,bmw,bmh,area;
FILE *fis;
pixcol *pix;
char s[MAXWLG];

bmw=BKGWIDTH; bmh=BKGHEIGHT;
area=bmw*bmh;
if(!(pix=(pixcol *)malloc((area+1)*sizeof(pixcol)))){printf("Out of memory");}

if(!(fis=fopen(numefis,"r"))){printf("File '%s' could not be open\r\n",numefis);exit(1);}

for(i=1;i<=area;i++){
  err=fisgetw(fis,s,&lincr); pix[i]=hexpix(s,screen); /*no error checking*/
}

fclose(fis);

return pix;
}


/*number of pixels by which to shift background on x and y*/
void bkshift(sgob *objs,int nob,int *npx,int *npy)
{int i,to=1;
REALN ix2,iy2,iz2,jx2,jy2,jz2,kx2,ky2,kz2,
      bmw,bmh,
      tt,sintt,costt;

bmw=BKGWIDTH; bmh=BKGHEIGHT;

while(objs[to].otyp!=21){to++; if(to>=nob){return;}} /*ref. object*/

    i=to;
    ix2=objs[i].vx[1]-objs[i].vx[0];
    jx2=objs[i].vx[2]-objs[i].vx[0];
    kx2=objs[i].vx[3]-objs[i].vx[0];
      iy2=objs[i].vy[1]-objs[i].vy[0];
      jy2=objs[i].vy[2]-objs[i].vy[0];
      ky2=objs[i].vy[3]-objs[i].vy[0];
        iz2=objs[i].vz[1]-objs[i].vz[0];
        jz2=objs[i].vz[2]-objs[i].vz[0];
        kz2=objs[i].vz[3]-objs[i].vz[0];

costt=kz2;
sintt=ky2;
tt=atan(sintt/costt);
if(costt>0){tt+=3.1416;}
(*npx)=-tt*bmw/6.2831853;

sintt=iz2;
tt=asin(sintt);
(*npy)=-tt*bmw/6.2831853;

}
